# ace::HashVector< _StType, _HashFunc >::iterator Class Reference

Iterator class needed (simple - only forward, no random access!). More...

`#include <hash_vector.h>`

List of all members.

## Public Member Functions
| iterator (const typename _hash_t::_buckets_t &hash_buckets)
| Constructs "beginning" iterator.
| iterator (const typename _hash_t::_buckets_t &hash_buckets, typename _hash_t::_buckets_t::const_iterator i_bucket)
| Constructs iterator pointing at the beginning of given bucket (or next in row, which is non empty).
| iterator (const typename _hash_t::_buckets_t &hash_buckets, typename _hash_t::_buckets_t::const_iterator i_bucket, typename _hash_t::_store_t::const_iterator i_item)
| Constructs iterator pointing at given bucket and given bucket item (must be valid).
iterator & | operator++ (void)
| Prefix inc operator.
const _hash_t::type & | operator* (void) const
| Dereference operator.
bool | operator== (const iterator &rhs) const
| Equality operator.
bool | operator!= (const iterator &rhs) const
| Unequality operator.
## Private Types
typedef HashVector< _StType, _HashFunc > | _hash_t
## Private Member Functions
bool | _end (void) const
| End reached?
void | _init_item (void)
void | _next (void)
## Private Attributes
_hash_t::_buckets_t::const_iterator | _end_of_buckets
| Iterator pointing at buckets end.
_hash_t::_buckets_t::const_iterator | _i_bucket
| Iterator pointing to current bucket.
_hash_t::_store_t::const_iterator | _i_item
| Iterator pointing to current bucket item.

## Detailed Description

### template<class _StType, class _HashFunc>
class ace::HashVector< _StType, _HashFunc >::iterator

Iterator class needed (simple - only forward, no random access!).

## Member Typedef Documentation

template<class _StType, class _HashFunc>

typedef HashVector<_StType, _HashFunc> ace::HashVector< _StType, _HashFunc >::iterator::_hash_t`[private]`

## Constructor & Destructor Documentation

template<class _StType, class _HashFunc>

ace::HashVector< _StType, _HashFunc >::iterator::iterator | ( | const typename _hash_t::_buckets_t & | hash_buckets | ) | `[inline, explicit]`

Constructs "beginning" iterator.

Parameters:

  | hash_buckets | Reference to const instance of hash table.

template<class _StType, class _HashFunc>

ace::HashVector< _StType, _HashFunc >::iterator::iterator | ( | const typename _hash_t::_buckets_t & | hash_buckets,
|  | typename _hash_t::_buckets_t::const_iterator | i_bucket |
| ) |  |  | `[inline, explicit]`

Constructs iterator pointing at the beginning of given bucket (or next in row, which is non empty).

Parameters:

  | hash_buckets | Reference to const instance of hash table.
  | i_bucket | Const iterator to certain bucket within given hash table.

template<class _StType, class _HashFunc>

ace::HashVector< _StType, _HashFunc >::iterator::iterator | ( | const typename _hash_t::_buckets_t & | hash_buckets,
|  | typename _hash_t::_buckets_t::const_iterator | i_bucket,
|  | typename _hash_t::_store_t::const_iterator | i_item |
| ) |  |  | `[inline, explicit]`

Constructs iterator pointing at given bucket and given bucket item (must be valid).

Parameters:

  | hash_buckets | Reference to const instance of hash table.
  | i_bucket | Const iterator to certain bucket within given hash table.
  | i_item | Const iterator to certain item within given bucket of given hash table.

## Member Function Documentation

template<class _StType, class _HashFunc>

bool ace::HashVector< _StType, _HashFunc >::iterator::_end | ( | void |  | ) | const`[inline, private]`

End reached?

template<class _StType, class _HashFunc>

void ace::HashVector< _StType, _HashFunc >::iterator::_init_item | ( | void |  | ) | `[inline, private]`

template<class _StType, class _HashFunc>

void ace::HashVector< _StType, _HashFunc >::iterator::_next | ( | void |  | ) | `[inline, private]`

template<class _StType, class _HashFunc>

iterator& ace::HashVector< _StType, _HashFunc >::iterator::operator++ | ( | void |  | ) | `[inline]`

Prefix inc operator.

template<class _StType, class _HashFunc>

const _hash_t::type& ace::HashVector< _StType, _HashFunc >::iterator::operator* | ( | void |  | ) | const`[inline]`

Dereference operator.

Returns:
  Reference to const instance of stored type.

template<class _StType, class _HashFunc>

bool ace::HashVector< _StType, _HashFunc >::iterator::operator== | ( | const iterator & | rhs | ) | const`[inline]`

Equality operator.

Parameters:

  | rhs | Iterator to be compared for equality.

Returns:
  True, if this iterator is equal to the passed one.

template<class _StType, class _HashFunc>

bool ace::HashVector< _StType, _HashFunc >::iterator::operator!= | ( | const iterator & | rhs | ) | const`[inline]`

Unequality operator.

Parameters:

  | rhs | Iterator to be compared for unequality.

Returns:
  True, if this iterator is not equal to the passed one.

## Member Data Documentation

template<class _StType, class _HashFunc>

_hash_t::_buckets_t::const_iterator ace::HashVector< _StType, _HashFunc >::iterator::_end_of_buckets`[private]`

Iterator pointing at buckets end.

template<class _StType, class _HashFunc>

_hash_t::_buckets_t::const_iterator ace::HashVector< _StType, _HashFunc >::iterator::_i_bucket`[private]`

Iterator pointing to current bucket.

template<class _StType, class _HashFunc>

_hash_t::_store_t::const_iterator ace::HashVector< _StType, _HashFunc >::iterator::_i_item`[private]`

Iterator pointing to current bucket item.

The documentation for this class was generated from the following file:

- proto/Source/hash_vector.h